#ifndef TERREGLWIDGET_H
#define TERREGLWIDGET_H
#include <QGLWidget>
#include <QLabel>

typedef enum {frZENITH, frSATEL, toEARTH_c, toEARTH_E, frSOLEIL, toLUNE_C, toLUNE_A} ModePtVue;

class CineSpace;
class ConfEarthDialog;

class TerreGLWidget : public QGLWidget
{
    Q_OBJECT
public:
    TerreGLWidget(CineSpace *cine);
    QSize sizeHint () const ;
    friend class ConfEarthDialog;
    friend class CineSpace;

private :
    CineSpace *cine;
    QLabel *labelHelp;
    int width1, height1;
    int	perspective;    /* Flag utilisation perspectives  */
    double gainAngle, AngleVueIni; /* en degrés */
    double xScene, yScene, zScene;
    double gainDist, distSceneIni;
    double aziScene, aziSceneIni, sitScene, sitSceneIni;
    bool drawLune;
    bool drawSatellites;
    ConfEarthDialog *confEarthDialog;
    GLuint dl_Terre;
    GLuint dl_Lune;
    GLuint dl_Sat;
    GLuint dl_Orbs[8];
    void setProjection();

protected:
    ModePtVue modePtVue;
    void initializeGL();
    void resizeGL(int width, int height);
    void paintGL();
    void keyPressEvent(QKeyEvent *event);
    void closeEvent(QCloseEvent *event);

private slots:
    void afficheHelpSlot() {labelHelp->show();}
    void confDialogSlot();
    void grabImageSlot();
};

#endif // TERREGLWIDGET_H
