#ifndef CONFSTARSDIALOG_H
#define CONFSTARSDIALOG_H

#include <QDialog>
#include <QLabel>

namespace Ui {
    class ConfStarsDialog;
}

typedef struct {int idx; char nom[40];} idxNomCons;

class StarsWidget;

class ConfStarsDialog : public QDialog
{
    Q_OBJECT

public:
    ConfStarsDialog(StarsWidget *s, QWidget *parent = 0);
    void init();
    ~ConfStarsDialog();

private:
    bool notinitok;
    QLabel *labelHelpConf;
    Ui::ConfStarsDialog *ui;
    StarsWidget *stars;
    idxNomCons *vecCons;

private slots:    
    void on_comboBox_selConst_currentIndexChanged(int index);
    void on_pushButton_clicked();
    void on_doubleSpinBox_mag_valueChanged(double );
    void on_doubleSpinBox_alf_valueChanged(double );
    void on_doubleSpinBox_sit_valueChanged(double );
    void on_doubleSpinBox_azi_valueChanged(double );
    void on_doubleSpinBox_kSL_valueChanged(double );

    void on_checkBox_nomStar_toggled(bool checked);
    void on_checkBox_consName_toggled(bool checked);
    void on_checkBox_sgName_toggled(bool checked);
    void on_checkBox_drawConstel_toggled(bool checked);
    void on_checkBox_Champ_toggled(bool checked);
    void on_checkBox_Horiz_toggled(bool checked);
    void on_radioButton_gris_toggled(bool checked);
    void on_radioButton_blanc_toggled(bool checked);
    void on_radioButton_noir_toggled(bool checked);

    void slider_mag_setValue(double);
    void slider_alf_setValue(double);
    void slider_sit_setValue(double);
    void slider_azi_setValue(double);
    void slider_kSL_setValue(double);

    void spinbox_mag_setValue(int);
    void spinbox_alf_setValue(int);
    void spinbox_sit_setValue(int);
    void spinbox_azi_setValue(int);
    void spinbox_kSL_setValue(int);

    void on_checkBox_Lune_toggled(bool checked);

    void on_checkBox_Planetes_toggled(bool checked);

    void on_checkBox_stellites_toggled(bool checked);

protected:
    void closeEvent(QCloseEvent *event);
};

#endif // CONFSTARSDIALOG_H
