#ifndef PLANETS_H
#define PLANETS_H
#include <QString>
#include "planetes.h"

// CLASSE STATIQUE. Pas besoinde créer d'instance.

class Planets {
public:

 /* -------------------------------------------------------
 Variables de la classe Planets mises a jour par Planets.etat(t)
  * ------------------------------------------------------- */
    /** Si true, calcul dans le référentiel fixe J2000, sinon dans le reférentiel de l'équinoxe moyen de la date */
    static int refJ2000;

    /** Si true, methode spherique, sinon, methode cartesienne */
    static int methodeSpherique;

    /* Dernier instant de calcul de la position des planetes */
    static double tcou, tpos[8];

    /** Positions des planètes par rapport au Soleil dans Re(cliptique), et lamba, beta, rho */
    static double v8x6_OP_e[8][6];

    /** Positions des planètes par rapport à la Terre dans Rc(éleste) */
    static double v8x3_TP_c[8][3];

    /** Magnitudes apparentes pifométrées */
    static double magpla[8];

    /** Noms des 8 planetes */
    static QString noms[8];

    // Configuration repere de calcul et mode de calcul
    static void config(bool ref, bool sphere);

    /** Positions à l'instant j compté en jours après le 1er janvier 2000 a midi a Greenwich (J2000.0). */
    static void etat(double j, double precion);
	
    static void test() ;	

    /** Impression position planetes dans Rc .
    */
    static void print();
};




#endif // PLANETS_H

