#ifndef REPMOYENS_H
#define REPMOYENS_H

// Classes statiques. Pas de constructeur

class Reperes
{
public:
// Pas de constructeur
    Reperes(){}
// variables statiques écliptiques
    static double lastsJe1, lastsJe2;
    static double eta, sigma, esse, ceta, seta, m3_EE21[9];

// variables statiques équatoriales
    static double lastsJc1, lastsJc2;
    static double zede, teta, zeta, cteta, steta, m3_CC21[9], m3_CCvm[9];

// Variables statiques partagees
    static const double varPrecSiecle;
    static const double varObliqSiecle;
    static const double eps0_dg;
    static double lastsJObliq, epsilon, epsilon_dg, coseps, sineps;
    static double m3_CE[9];
    static double lastCorNut, deltaEpsilon, deltaPsi;
    static const double errBradleyMax, errBradSiecle;



// Mise a jour du changement de coordonnnees ecliptiques moyennes
// Entrees :
//   sJ1 : premiere date en siècles juliens depuis J2000
//         c'est a priori celle a laquelle on possede les coordonnees de l'astre
//   sJ2 : deuxième date en siècles juliens depuis J2000
//         c'est a priori celle a laquelle on desire les coordonnees de l'astre
// Mise à jour des angles eta, sigma et esse et de la matrice m3_EE21
static void majEclipMoy(double sJ1, double sJ2);

// Mise a jour du changement de coordonnnees equatoriales moyennes
// Entrees :
//   sJ1 : premiere date en siècles juliens depuis J2000
//         c'est a priori celle a laquelle on possede les coordonnees de l'astre
//   sJ2 : deuxième date en siècles juliens depuis J2000
//         c'est a priori celle a laquelle on desire les coordonnees de l'astre
// Mise à jour des angles zeta, zede et teta et de la matrice m3_CC21
static void majEquatMoy(double sJ1, double sJ2);


// Mise à jour de l'obliquité
// Entree :
//     sj 	Instant du calcul en siecles juliens / J2000 (TE ou TU)
// Mises à jour : :
//   epsilon_dg : obliquité moyenne à la date t_j en degré
//   epsilon    : idem en radian
//   coseps, sineps : lignes trigo.
//   m3_CE      : matrice de passage Celeste -> Ecliptique à la date sj
//   lastsJObliq: dernier instant de calcul en siècle/J2000
static void obliquite(double T);

// Conversion de coordonnnees ecliptiques moyennes d'une etoile d'une date vers une autre date
// !!!!!!!!    IL FAUT QUE majEclipMoy AIT ETE APPELE AU PREALABLE !!!!!!!!!!
//   lConnu, bConnu : coord. ecli. connues en RADIANS
//   lInc, sinbInc : coord. ecli. cherchées en RADIAN et SINUS
//   direct :
//      si vrai : (lConnu, bConnu) sont les coordonnées initiales et (lInc, bInc) les coord. finales cherchées
//      si faux : (lConnu, bConnu) sont les coordonnées finales et (lInc, bInc) les coord. initiales cherchées
static void chgCoordsEclip(double *lInc, double *bInc, double *sinbInc, double lConnu, double bConnu, bool direct);


// Conversion de coordonnnees equatoriales moyennes d'une etoile d'une date vers une autre date
// !!!!!!!!    IL FAUT QUE majEquatMoy AIT ETE APPELE AU PREALABLE !!!!!!!!!!
//   aConnu, dConnu : coord. equatoriales. connues en RADIANS
//   aInc, sindInc : coord. equatoriales. cherchées en RADIAN et SINUS
//   direct :
//      si vrai : (aConnu, dConnu) sont les coordonnées initiales et (aInc, dInc) les coord. finales cherchées
//      si faux : (aConnu, dConnu) sont les coordonnées finales et (aInc, dInc) les coord. initiales cherchées
static void chgCoordsEquat(double *aInc, double *dInc, double *sindInc, double aConnu, double dConnu, bool direct);


// Mise à jour pour correction nutation (mouv. de Bradley)
//  Entrees :
//     sJ 	Instant du calcul en siècles juliens / J2000 (TE ou TU)
//    precismax : vrai si precision max demandée
//  Mises à jour de :
//    deltaEpsilon : variation d'obliquité de l'axe céleste
//    deltaPsi     : variation de l'axe céleste en longitude écliptique
//    m3_CCvm      : matrice de passage repère vrai -> repère moyen
//    tsNutation   : memo dernier instant de calcul, en siècle/J2000
static void majEclipVrai(double sJ, bool precismax);

// Calcul de la correction des coordonnées équatoriales due à la nutation (mouv. de Bradley)
//   Suppose l'appel au préalable de obliquite et majEclipVrai pour la mise-à-jour de
//   l'obliquité Epsilon et des variations deltaPsi et deltaEpsilon
//  Entrees :
//     alf, dec : Coordonnées équatoriales à corriger
//  Sorties :
//     deltaAlf, deltaDec : corrections à appliquer
//  Remarque : Une autre approche consiste à appliquer la matrice m3_CCvm aux composantes
//     de la direction de l'objet céleste.

static void deltaCoordEquatNutation(double *deltaAlf, double *deltaDec, double alf, double dec);
};

#endif // REPMOYENS_H
