#ifndef STARSWIDGET_H
#define STARSWIDGET_H
#include <QtGui>
#include "etoile.h"
#include "confstarsdialog.h"

#define ECLAIRAGE
typedef enum {NOIR, BLANC, GRIS} Eclairage;

class CineSpace;

class StarsWidget : public QWidget
{
    Q_OBJECT
public:
    friend class CineSpace;
    StarsWidget(int w, int h, Etoile *tabStars, Constellation *tabCons, CineSpace *cine);
    QSize sizeHint () const ;
//    void majLongiLati(double longitude, double latitude);
    friend class ConfStarsDialog;

protected:

private :
    CineSpace *cine;
    int whint, hhint;
//    double longitude, latitude;
//    double m3_GA[9], v3_GA[3];

    QColor couleurCiel, couleurStars;
    QLabel *labelHelp;
    bool flagHoriz;
    bool flagChamp;
    Eclairage clarte;
    bool drawLune;
    bool drawPlanetes;
    bool drawSatellites;
    bool drawConstel;
    bool drawSgName;
    bool drawStarName;
    bool drawConsName;
    /*-------------------*/
    /* Description scene */
    /*-------------------*/
    double gainpix;
    int decalx, decaly;
    int dimConf;
    int selConstel; // Constellation sélectionnée
    Constellation *tabCons;
    Etoile *tabStars;
    double magmin;
    double kmulSL;
    // Angle de visée
    double alfamax, as2;
    double xInterVis, yInterVis, angSol, angVis;
    bool interVisOk;
    // Position et direction de visée
    double aziVisee;
    double sitVisee; // De eps radians à (PI/2-eps) radians
    double RayHoriz, AltHoriz;
    double m3_AP[9];
    ConfStarsDialog *confStarsDialog;

    void initConf();
    void majVisee();
    void majColors();
    bool uRaToxy(int *ix, int *iy, double *h, int ix0, int iy0, double factor, double *u);
    bool uRcToxy(int *ix, int *iy, double *h, int ix0, int iy0, double factor, double *u, bool near);
    bool uSolRgToxy(int *ix, int *iy, double *h, int ix0, int iy0, double factor, double *u);

    void paintScene(QPainter &painter);

private slots:
    void confDialogSlot();
    void afficheHelpSlot() {labelHelp->show();}
    void grabImageSlot();

protected:
    void paintEvent(QPaintEvent *);
    void closeEvent(QCloseEvent *event);

};

#endif // STARSWIDGET_H
