#ifndef TIMEDIALOG_H
#define TIMEDIALOG_H

#include <QDialog>
#include <QLabel>

namespace Ui {
    class TimeDialog;
}

class CineSpace;

class TimeDialog : public QDialog
{
    Q_OBJECT

public:
//    TimeDialog(Stars *s, QWidget *parent = 0);
    TimeDialog(CineSpace *s, QWidget *parent = 0);
    ~TimeDialog();
    void updateCourant(double time);
    void init();
    void setAccel(double accel);
    void setCreneau(double cre);

signals:
    void doSynchro();


private:
    bool notinitok;
    Ui::TimeDialog *ui;
    QLabel *labelHelpOrd;
    CineSpace *stars;
    int jDeb, moDeb, aDeb, hDeb, mnDeb, sDeb;
    int jFin, moFin, aFin, hFin, mnFin, sFin;
    double jjDeb, jjFin;
    double creneau;
    double decalage;
    double periode, accel;

    void update_dateDeb();
    void update_dateFin();
    void update_jjDeb();
    void update_jjFin();

private slots:
    void on_pushButton_Aide_clicked();
    void on_comboBox_scenar_currentIndexChanged(int index);
    void on_doubleSpinBox_decalTime_valueChanged(double );
    void on_pushButton_Synchro_clicked();
    void on_doubleSpinBox_jperiode_valueChanged(double );
    void on_doubleSpinBox_jcreneau_valueChanged(double );
    void on_doubleSpinBox_accel_valueChanged(double );
    void on_spinBox_sFin_editingFinished();
    void on_spinBox_mFin_editingFinished();
    void on_spinBox_hFin_editingFinished();
    void on_spinBox_anneeFin_editingFinished();
    void on_spinBox_moisFin_editingFinished();
    void on_spinBox_jourFin_editingFinished();
    void on_doubleSpinBox_jjDeb_editingFinished();
    void on_spinBox_sDeb_editingFinished();
    void on_spinBox_mDeb_editingFinished();
    void on_spinBox_hDeb_editingFinished();
    void on_spinBox_anneeDeb_editingFinished();
    void on_spinBox_moisDeb_editingFinished();
    void on_doubleSpinBox_jjFin_editingFinished();
    void on_spinBox_jourDeb_editingFinished();

protected:
    void closeEvent(QCloseEvent *event);
};

#endif // TIMEDIALOG_H
