#ifndef UNIVGLWIDGET_H
#define UNIVGLWIDGET_H
#include <QGLWidget>
#include <QLabel>

class CineSpace;

class UnivGLWidget : public QGLWidget
{
    Q_OBJECT
public:
    UnivGLWidget(CineSpace *cine);
    QSize sizeHint () const ;
    friend class CineSpace;

private :
    CineSpace *cine;
    QLabel *labelHelp;
    int width1, height1;
    int	perspective;    /* Flag utilisation perspectives  */
    double gainAngle, AngleVueIni; /* en degrés */
    double xScene, yScene, zScene;
    double gainDist, distSceneIni;
    double aziScene, aziSceneIni, sitScene, sitSceneIni;
    GLuint dl_Planetes[8];
    GLuint dl_Lune;
    GLuint dl_Soleil;
    GLuint dl_Orbs[8];
    void setProjection();
    double terlun;

protected:
    void initializeGL();
    void resizeGL(int width, int height);
    void paintGL();
    void keyPressEvent(QKeyEvent *event);
    void closeEvent(QCloseEvent *event);

private slots:
    void afficheHelpSlot() {labelHelp->show();}
    void confDialogSlot();
    void grabImageSlot();
};

#endif // UNIVGLWIDGET_H
