#include "elem.h"
#include <math.h>
/**
 * Utilitaires mathematiques divers
 <UL>
 <LI>Reste de a modulo b, compris entre 0 et b
 <LI>	double mod(double a, double b);
 <LI>Reste de a modulo b, compris entre -b/2 et b/2
 <LI>	double mod2(double a, double b);
 <LI>Calcul d'un des 12 systemes de 3 angles associes a une matrice de rotation
 <LI>	void mrot2angs(double []angs, double [][]r, int L, int M, int N);
 </UL>
 * @author Michel Llibre - ONERA/DCSD.
 */	

/** Fonction renvoyant a modulo b compris entre 0 et b
     @param a    Le dividende (double)
     @param b    Le diviseur (double)
     @return     Le reste : a modulo b (double)
	 */
double realmod(double a, double b)
{
    return (a - b*floor(a/b)) ;
}

/** Fonction renvoyant a modulo b compris entre -b/2 et b/2
     @param a    Le dividende (double)
     @param b    Le diviseur (double)
     @return     Le reste : a modulo b (double)
	 */
double realmod2(double a, double b)
{
    return (a - b*floor((a+b/2.)/b)) ;
}

double toDegrees(double x) { return x*180./M_PI; }
double toRadians(double x) { return x*M_PI/180.; }

/* Une procédure de test */
//void testelem()
//{
//    printf("realmod(115.,60.) = %lf\n", realmod(115.,60.)) ;
//    printf("realmod2(115.,60.) = %lf\n", realmod2(115.,60.)) ;
//}
